package no.valg.valgnatt.database.hibernate;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Getter;
import lombok.NoArgsConstructor;
import no.valg.valgnatt.database.domene.ValgType;
import org.hibernate.annotations.Immutable;

import javax.persistence.Column;
import javax.persistence.Embeddable;

@Embeddable
@Immutable
@NoArgsConstructor //Hibernate-krav
@AllArgsConstructor //Builder-krav
@Builder
public class StemmeoppgjorId implements java.io.Serializable {

	@Column(name = "valgtype")
	private String valgtype;

	@Getter
	@Column(name = "kommnr", nullable = false, length = 4)
	private String kommnr;

	@Getter
	@Column(name = "kretsnr", nullable = false, length = 4)
	private String kretsnr;

	public StemmeoppgjorId(ValgType valgtype, String kommnr, String kretsnr) {
		this.valgtype = valgtype.name();
		this.kommnr = kommnr;
		this.kretsnr = kretsnr;
	}

	public ValgType getValgtype() {
		return ValgType.valueOf(this.valgtype);
	}

	@Override
	public boolean equals(Object other) {
		return other != null && other.getClass() == this.getClass() && id().equals(((StemmeoppgjorId) other).id());
	}

	public String id() {
		return valgtype + "-" + kommnr + "-" + kretsnr;
	}

	@Override
	public int hashCode() {
		return id().hashCode();
	}

}
